//+---------------------------------------------------------------------+
//|                                                 RD-TrendTrigger.mq5 | 
//|                                   Copyright  2007, Paul Y. Shimada | 
//|                                             www.strategybuilder.com | 
//|	      Notes := Modified version of Trend Trigger Factor by mikesbon | 
//|	      (thanks to perkyz)                                            |
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2007, Paul Y. Shimada"
#property link "www.strategybuilder.com"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----       MediumSlateBlue 
#property indicator_color1 clrMediumSlateBlue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  "RD-TrendTrigger"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 +50.0
#property indicator_level2 -50.0
#property indicator_levelcolor clrMagenta
#property indicator_levelstyle STYLE_DASHDOTDOT
//+----------------------------------------------+
//|    XMA                         |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//----    CMoving_Average  CT3   SmoothAlgorithms.mqh
CT3 T3;
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint Regress=15;
input uint T3Length=5;//                     
input int T3Phase=70; // 
input int Shift=0; //      
//+----------------------------------------------+

//----   ,    
//      
double IndBuffer[];

//----      
int min_rates_,min_rates_total;
//+------------------------------------------------------------------+   
//| RD-TrendTrigger indicator initialization function                | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_=int(2*Regress+1);
   min_rates_total=min_rates_+1;

//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//----       
   ArraySetAsSeries(IndBuffer,true);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"RD-TrendTrigger");

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+ 
//| RD-TrendTrigger iteration function                               | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &Time[],
                const double &Open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &Tick_Volume[],
                const long &Volume[],
                const int &Spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----       
   double HighestHighRecent,HighestHighOlder,LowestLowRecent,LowestLowOlder,BuyPower,SellPower,TTF,Res;
//----   
   int limit,maxbar;
   
   maxbar=rates_total-min_rates_;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates_total-1; //      
   else limit=rates_total-prev_calculated;  //       

//----         
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);

//----    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      HighestHighRecent=High[ArrayMaximum(High,bar,Regress)];
      HighestHighOlder=High[ArrayMaximum(High,bar+Regress,Regress)];
      LowestLowRecent=Low[ArrayMinimum(Low,bar,Regress)];
      LowestLowOlder=Low[ArrayMinimum(Low,bar+Regress,Regress)];
      BuyPower=HighestHighRecent-LowestLowOlder;
      SellPower=HighestHighOlder-LowestLowRecent;
      Res=BuyPower+SellPower;
      if(Res) TTF=(BuyPower-SellPower)/(0.5 *Res)*100;
      else TTF=0.0;

      IndBuffer[bar]=T3.T3Series(maxbar,prev_calculated,rates_total,MODE_T3,T3Phase,T3Length,TTF,bar,true);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
